/*****************************************************************************
* Ferns' Graphics Library version 3.0                                        *
*                                                                            *
* The disclaimer :                                                           *
*     THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,        *
*     EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE        *
*     IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR     *
*     PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE     *
*     PRODUCT IS WITH YOU.  SHOULD THE PRODUCT PROVE DEFECTIVE, YOU          *
*     ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.      *
*     IN NO EVENT WILL FERNS PAANAKKER BE LIABLE TO YOU FOR                  *
*     DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR                 *
*     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE       *
*     THE PRODUCT (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA         *
*     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD          *
*     PARTIES OR A FAILURE OF THE PRODUCT TO OPERATE WITH ANY OTHER          *
*     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF      *
*     THE POSSIBILITY OF SUCH DAMAGES.                                       *
*                                                                            *
* A plain and simple demo for all the features of FGLib version 3.0          *
*                                                                            *
*                                                                            *
* (C)Copyright Ferns Paanakker 1995-96.                                      *
*****************************************************************************/
#include "mcursors.ch"     // For some mousepointer shapes
#include "fgl.ch"          // General include
#include "fgbutton.ch"     // A handle include for standard buttons
#include "box.ch"
#include "inkey.ch"

MEMVAR GetList

PROCEDURE Main()
   Local i,terug,j
   local XMAX,YMAX,Length,Xpos,Ypos
   Local Test1 := "Ferns Paanakker"
   Local Test2 := "(070)3801724"
   Local Test3 := "Holten         "
   Local achter,achter2,Font
   Local plaat,Num,temp,naam
   Local Fonts
   Local ModeStr := {"800x600x16","800x600x256","800x600x32k","800x600x64k","640x480x16","640x480x256","640x480x32k","640x480x64k","Einde"}
   Local Modes := {FGL_GRAPHICS_800_600_16,FGL_GRAPHICS_800_600_256,;
      FGL_GRAPHICS_800_600_32k,FGL_GRAPHICS_800_600_64k,FGL_GRAPHICS_640_480_16,FGL_GRAPHICS_640_480_256,FGL_GRAPHICS_640_480_32k,FGL_GRAPHICS_640_480_64k,NIL}

	Local intro := {"Some of the features of FGLib 3.0:",;
	                "",;
						 "- Supports all graphic modes (VGA and SuperVGA).",;
	                "- Has a replaced terminal driver.",;
						 "- Supports all graphic primitives.",;
	                "- Supports Truecolor emulation",;
						 "- Read and Write pictures (includes dithering)",;
	                "- Supports logical operations (SET,XOR,OR,AND)",;
						 "- Use patterns (solid and transparent)",;
	                "- Use a transparent color.",;
						 "- Use fonts (fixed size and proportional)",;
						 "- User-definable mouse.",;
	                "- Cursor emulation.",;
						 "- Uses DIB and DDB for images.",;
						 "- Scale images"}
   SET SCOREBOARD OFF
   SET CURSOR OFF
   SetColor("N/W,N/W*")
   CLS
   SETBLINK(.F.)                                 // no blinking
   SET INTENSITY OFF
   @ 7,4,21,26 BOX B_SINGLE_DOUBLE
   @ 7,5 SAY "Choose videomode"
   plaat := ACHOICE(8,5,20,25,ModeStr)
   IF (plaat == 9 .OR. plaat == 0)
      QUIT
   ENDIF
   IF EMPTY(FGLSetMode(-Modes[plaat]))
		FGLSetMode(FGL_TEXT_NORMAL)
		SETCOLOR("W/N")
		? "Mode set failed...exiting"
      QUIT
   ENDIF
	FGLSetMode(Modes[plaat])
	LoadButtons()      // Load the standard buttons. It's wise to ALWAYS do this.
   SET INTENSITY ON   // In graphic mode!!!
   YMAX := FGLSetMode()[FGL_MODE_GRAPH_MAXY]
   XMAX := FGLSetMode()[FGL_MODE_GRAPH_MAXX]

   // If the Open Dialog returns a file, open the DBF
   If !Empty("samples.dbf")
      If !Empty(ALIAS())        // If a file is open close it
         DbCloseArea()
      Endif
      DbUseArea(.T.,,"samples.dbf")
   Endif

   FGLMShow()
   Gradient(3)
	Font := FGLFontLoad("font\door.fnt")
   FGLFontSet(Font)
   FGLSetColor(clWhite)

   Length := FGLWriteAt("Ferns' Graphics Library")
   Xpos := INT((XMAX/2) - (Length/2))
   FGLWriteAt(Xpos,30,,,"Ferns' Graphics Library")

   Length := FGLWriteAt("Version 3.0")
   Xpos := INT((XMAX/2) - (Length/2))
   FGLWriteAt(Xpos,YMAX-30-Font[FGL_FNT_HEIGHT],,,"Version 3.0")
	FGLFontErase(Font)

	BEWindow(100,80,600,450,"FGLib version 3.0 DEMO")

	Font := FGLFontLoad("font\arial16.fnt")   // Load a different font.
	IF .NOT. EMPTY(Font)
	 FGLFontSet(Font)
    FGLSetColor(clBlack)
    FOR i := 1 TO LEN(Intro)
      FGLWriteAt(110,130+((i-1)*Font[FGL_FNT_HEIGHT]),,,Intro[i])
    NEXT
	ENDIF

	FGLMShow()
	INKEY(0)
   Gradient(3)
	MyBrowse(5,5,25,75)
   DbCloseArea()
   Gradient(2)
	TransDemo()
	INKEY(0)
	Gradient(2)
	PrimiDemo()
	INKEY(0)
   Gradient(1)
   BEWindow(100,310,150,170,'Red components')
   ShowColors(110,340,'R')
   BEWindow(325,210,150,170,'Green components')
   ShowColors(335,240,'G')
   BEWindow(550,110,150,170,'Blue components')
   ShowColors(560,140,'B')
	INKEY(0)
   BEWindow(30,30,300,220,'Normal GET Demo')
	achter := FGLLoadBMP('bmp\ok.bmp')
	FGLShowDIB(50,200,achter,FGL_IMG_MAPONCURRENT)
	achter := FGLLoadBMP('bmp\cancel.bmp')
   FGLShowDIB(150,200,achter,FGL_IMG_MAPONCURRENT)
	achter := FGLLoadBMP('bmp\help.bmp')
	FGLShowDIB(250,200,achter,FGL_IMG_MAPONCURRENT)
   @ 5,5 SAY "Input1 :" GET Test1
   @ 7,5 SAY "Input2 :" GET Test2
   @ 9,5 SAY "Input3 :" GET Test3
   SET CURSOR ON
   READ
	SET CURSOR OFF
	ShowPict(50,30,'bmp\sven.bmp')
	ShowPict(250,130,'bmp\out4.bmp')
	ShowPict(0,0,'bmp\goldeney.pcx')
	INKEY(0)
	ZoomIn(50,200)
	INKEY(0)
   QUIT
RETURN

PROCEDURE ZoomIn(X,Y)
Local Xpos,Ypos,Width,Height
Local aState,Enlarge
Local nKey
Local aSave
Local ScrX,ScrY

 IF EMPTY(X) ; X := 0 ; ENDIF
 IF EMPTY(Y) ; Y := 0 ; ENDIF
 aState := FGLMState()
 FGLMHide()
 Xpos := aState[FGLM_STATE_X]
 Ypos := aState[FGLM_STATE_Y]
 Width := 30
 Height := 30
 ScrX := 200
 ScrY := 200
 aSave := FGLGetBackground(X,Y,X+ScrX,Y+ScrY)
 BEWindow(X,Y,ScrX,ScrY,"ZoomIn for FGLib 3.0")
 Enlarge := FGLGetBackground(Xpos,Ypos,Xpos+Width,Ypos+Height)
 FGLPutScale(X+6,Y+23,X+ScrX-6,Y+ScrY-6,Enlarge)
 FGLMShow()
 nKey := 0
 While (aState[FGLM_STATE_RIGHT] != FGLM_BUTTON_DOWN .AND. nKey != K_ESC)
  aState := FGLMState()
  nKey := INKEY()
  IF (nKey == K_UP .AND. Width > 16)
	Width-=2
	Height-=2
   Enlarge := FGLGetBackground(Xpos,Ypos,Xpos+Width,Ypos+Height)
   FGLPutScale(X+6,Y+23,X+ScrX-6,Y+ScrY-6,Enlarge)
  ENDIF

  IF (nKey == K_DOWN .AND. Width < 96)
	Width+=2
	Height+=2
   Enlarge := FGLGetBackground(Xpos,Ypos,Xpos+Width,Ypos+Height)
   FGLPutScale(X+6,Y+23,X+ScrX-6,Y+ScrY-6,Enlarge)
  ENDIF

  IF (aState[FGLM_STATE_LEFT] == FGLM_BUTTON_DOWN)
   IF (aState[FGLM_STATE_X] != Xpos .OR. aState[FGLM_STATE_Y] != Ypos)
    Enlarge := FGLGetBackground(Xpos,Ypos,Xpos+Width,Ypos+Height)
    FGLPutScale(X+6,Y+23,X+ScrX-6,Y+ScrY-6,Enlarge)
    Xpos := aState[FGLM_STATE_X]
    Ypos := aState[FGLM_STATE_Y]
	ENDIF
  ENDIF
 Enddo
 FGLPutBackground(X,Y,aSave)
RETURN

PROCEDURE ColorDialog(X,Y)
Local Xpos,Ypos,Width,Height,i
Local Kleuren := {clAqua,clBlack,clRed,clYellow,clBlue,clTeal,clSilver,;
                  clGreen,clWhite,clDkGray,clFuchsia,clLime,clMaroon,;
						clNavy,clOlive,clPurple,RGB(63,0,0),RGB(0,63,0),;
						RGB(0,0,63),RGB(63,128,255),RGB(128,63,255),;
						RGB(255,63,255),RGB(63,63,255),RGB(63,63,128)}

 DlgBox(X,Y,250,300,"ColorDialog")

 Xpos   := X+10
 Ypos   := Y+30
 Width  := 24
 Height := 16

 FOR i := 1 TO LEN(Kleuren)
  FGLFillRectangle(Xpos,Ypos,Xpos+Width,Ypos+Height,Kleuren[i])
  FGLRectangle(Xpos,Ypos,Xpos+Width,Ypos+Height,clBlack)
  Xpos += Width+5
  if (Xpos > X+230)
	Xpos := X+10
	Ypos += Height+5
  endif
 NEXT i

 TextButton(X+10,Y+250,50,30,"Ok")
 TextButton(X+75,Y+250,100,30,"Cancel")
 INKEY(0)
RETURN


PROCEDURE ShowColors(X,Y,C)
   Local i,j,Num
	FGLMHide()
   num := 0
   FOR i := 0 TO 15
      FOR j := 0 TO 15
        IF (C = 'R')
         FGLSetColor(RGB(Num,0,0)+FGL_DITHER16)
        ELSEIF (C = 'G')
         FGLSetColor(RGB(0,Num,0)+FGL_DITHER16)
        ELSEIF (C = 'B')
         FGLSetColor(RGB(0,0,Num)+FGL_DITHER16)
        ENDIF
         FGLFillRectangle(X+i*8,Y+j*8,X+i*8+7,Y+j*8+7)
        Num++
      NEXT j
   NEXT i
	FGLMShow()
RETURN


PROCEDURE NWallPaper(DDBpicture)
   local Xpos,Ypos

   IF (DDBpicture == NIL .OR. LEN(DDBpicture) == 0)
      RETURN
   ENDIF
	FGLMHide()
   Ypos := 0
   DO WHILE Ypos < FGLSetMode()[FGL_MODE_GRAPH_MAXY]
      Xpos := 0
      DO WHILE Xpos < FGLSetMode()[FGL_MODE_GRAPH_MAXX]
			FGLShowDDB(Xpos,Ypos,DDBPicture)
         Xpos += DDBpicture[6]
      ENDDO
      Ypos += DDBpicture[7]
   ENDDO
	FGLMShow()
RETURN


PROCEDURE MyBackGround(Pict,Flags,BackColor,hoe)
   local ScrnInfo,PictDDB
   local X,Y,Width,Height
   local i

   IF EMPTY(hoe)
      ScrnInfo := FGLSetMode()
      IF ScrnInfo[FGL_MODE_GRAPHIC] != 0
         Width := Pict[6]
         Height := Pict[7]
         X := INT((ScrnInfo[FGL_MODE_GRAPH_MAXX]/2)-(Width/2))
         Y := INT((ScrnInfo[FGL_MODE_GRAPH_MAXY]/2)-(Height/2))
         FGLMHide()
         FGLSetPenStyle(FGL_DITHER)
         FGLSetColor(BackColor)
         FGLFillRectangle(0,0,ScrnInfo[FGL_MODE_GRAPH_MAXX],ScrnInfo[FGL_MODE_GRAPH_MAXY])
         FGLShowDIB(X,Y,Pict,Flags)
         FGLMShow()
      ENDIF
   ELSE
      PictDDB := FGLMakeDDB(Pict,Flags)
      NwallPaper(PictDDB)
   ENDIF
RETURN


PROCEDURE Gradient(Welke)
Local Ytotaal,i,Xtotaal,Ystap

 Ytotaal := FGLSetMode()[FGL_MODE_GRAPH_MAXY]
 Xtotaal := FGLSetMode()[FGL_MODE_GRAPH_MAXX]
 Ystap := Ytotaal/255
 FGLMHide()
 FOR i := 0 TO 255 STEP 4
  DO CASE
   CASE Welke == 1
                 FGLSetColor(RGB(i,0,0))
   CASE Welke == 2
                 FGLSetColor(RGB(0,i,0))
   CASE Welke == 3
                 FGLSetColor(RGB(0,0,i))
  ENDCASE
   FGLFillRectangle(0,INT(Ystap*i),Xtotaal,INT(Ystap*(i+4)))
 NEXT
 FGLMShow()
RETURN

PROCEDURE ShowPict(X,Y,Naam)
Local temp
 FGLMCursor(FGLM_HOURGLASS)
 IF ((AT('.PCX',UPPER(NAAM))) != 0)
   temp := FGLLoadPCX(naam)
 ELSE
   temp := FGLLoadBMP(naam)
 ENDIF
 FGLMCursor(FGLM_NORMAL)
 IF (VALTYPE(temp) == 'A')
  BEWindow(X,Y,temp[6]+6+6,temp[7]+26+6,naam)
  FGLShowDIB(X+6,Y+26,temp,FGL_IMG_DITHER)
 ENDIF
 INKEY(0)
RETURN

/***
 A demo of all the graphic primitives.
***/
PROCEDURE PrimiDemo()
Local Font,i
 BEWindow(30,20,750,290,"The different graphical primitives")
 // Show a pie diagram
 FGLPie(100,100,30,50,0.0,45.0,clRed)
 FGLPie(100,100,30,50,45.0,292.8,clGreen)
 FGLPie(100,100,30,50,292.8,360.0,clBlue)

 // Show 2 filled rectangles
 FGLFillRectangle(200,50,300,150,RGB(64,34,192))
 FGLFillRectangle(350,50,450,150,5+FGL_INDEX)

 // Show a filled polygon
 FGLFillPolygon({{500,50},{600,50},{500,150},{600,150}},clYellow,clWhite)

 // Fill the area between 2 ellipses
 FGLFillEllipse(700,100,25,50,clGray,clRed)
 FGLEllipse(725,100,25,50,clBlue)
 FGLFill(710,100,clTeal)

 // Show an arc
 FGLArc(100,250,50,30,56.0,205.0,clWhite)
 FGLArc(100,250,50,30,205.0,56.0,clBlack)

 FGLRectangle(200,200,300,300,RGB(64,34,192))
 FGLEllipse(400,250,50,50,1+FGL_INDEX)

 // Show a filled polygon
 FGLPolygon({{500,200},{600,200},{500,300},{600,300}},clGreen)

 FGLSetColor(clGray)
 FOR i := 650 TO 750 STEP 5
  FGLLine(i,200,700,250)
  FGLLine(i,300,700,250)
 NEXT i
 FOR i := 200 TO 300 STEP 5
  FGLLine(650,i,700,250)
  FGLLine(750,i,700,250)
 NEXT i
 // Show some text
 Font := FGLFontLoad("font\door.fnt")
 FGLFontSet(Font)
 FGLWriteAt(665,225,clBlack,,"Text")
 FGLWriteAt(665-2,225-2,clWhite,,"Text")
 FGLFontErase(Font)
RETURN

/***
 A simple transparency demo.
***/
PROCEDURE TransDemo()
Local DDBPicture,Xpos,Ypos
Local X,Y,Pat

 FGLSetPenStyle(FGL_OPAQUE)
 FGLSetColor(clYellow)
 FGLSetBGColor(clBlack)
 Pat := 0
 FOR Y := 50 to 450 STEP 50
  FOR X := 50 to 600 STEP 50
   FGLSetPattern(Pat)
   FGLFillRectangle(X,Y,X+40,Y+40)
	Pat++
  NEXT X
 NEXT Y
 FGLSetPenStyle(FGL_DITHER)
RETURN
