/***
* Some useful function for Ferns' Graphics Library version 3.0.
*
* The different colors are defined in 'fgl.ch'
* These colors can be changed to the clBtnFace, clAppWorkSpace, etc.
* This way, you can let the user change your standard colors (like in Windows)
*
* The functions include:
*
*  - 3 different Window drawing functions (OS/2, Windows 3.11 and BeOS).
*  - A function for a Windows 3.11 dialog box.
*  - Functions to draw buttons.
*  - A function which loads standard buttons (arrows, etc.).
*
* Compile with : /n /a /w
*
* (C)Copyright Ferns Paanakker, 1995-1996.
***/
#include "fgl.ch"
#include "FGbutton.ch"

// Array used for the standard buttons
Static aFGLButton


/***
 This function draws a *very* nice looking window.
 BeOs style. You'll probably see a lot of this in the near future.
***/
PROCEDURE BEWindow(X1,Y1,lengte,hoogte,string)
Local i,aOldView,nLength
Local aFont

	aFont := FGLFontLoad("font\arial08.fnt")
	FGLFontSet(aFont)
	hoogte -= 20
	Y1 += 20

	FGLSetColor(clGray)
	FGLLine(X1,Y1,X1+lengte-1,Y1)
	FGLLine(X1,Y1+1,X1,Y1+hoogte)
	FGLSetColor(clBlack)
	FGLLine(X1+lengte,Y1,X1+lengte,Y1+hoogte-1)
	FGLLine(X1+1,Y1+hoogte,X1+lengte,Y1+hoogte)
	FGLSetColor(clWhite)
	FGLLine(X1+1,Y1+1,X1+lengte-2,Y1+1)
	FGLLine(X1+1,Y1+2,X1+1,Y1+hoogte-1)
	FGLSetColor(clLtGray)
	FGLLine(X1+lengte-1,Y1+1,X1+lengte-1,Y1+hoogte-2)
	FGLLine(X1+2,Y1+hoogte-1,X1+lengte-1,Y1+hoogte-1)
	i := 2
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i); i++

	FGLLine(X1+i,Y1+i,X1+lengte-i,Y1+i)
	FGLLine(X1+i,Y1+i+1,X1+i,Y1+hoogte-i)

	FGLSetColor(clWhite)
	FGLLine(X1+i,Y1+hoogte-i,X1+lengte-i,Y1+hoogte-i)
	FGLLine(X1+lengte-i,Y1+i+1,X1+lengte-i,Y1+hoogte-i)
	i++

   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clGray); i++
   FGLFillRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clLtGray)
	FGLLine(X1+lengte-i+1,Y1+hoogte-i-16,X1+lengte-1,Y1+hoogte-i-16,clGray)
	FGLLine(X1+lengte-i-16,Y1+hoogte-i+1,X1+lengte-i-16,Y1+hoogte-1,clGray)
	nLength := FGLWriteAt(string)
   FGLFillRectangle(X1,Y1-20,X1+nLength+40,Y1,clLtGray)
   FGLRectangle(X1,Y1-20,X1+nLength+40,Y1,clGray)
	FGLLine(X1+1,Y1-1,X1+1,Y1-19,clWhite)
	FGLLine(X1+2,Y1-19,X1+nLength+39,Y1-19,clWhite)
   //aOldView := FGLSetViewport(X1+5,Y1+i+1,X1+lengte-i-1,Y1+i+20)
   FGLWriteAt(X1+20,Y1-16,clBlack,,string)
   //FGLSetViewport(aOldView[1],aOldView[2],aOldView[3],aOldView[4])
	FGLFontErase(aFont)
RETURN

/***
 This function draw a OS/2 style window
***/
PROCEDURE OS2Window(X1,Y1,lengte,hoogte,string)
Local i,aOldView
 FGLMHide()
   i := 0
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clBlack); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clYellow); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clYellow); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clBlack); i++
   FGLFillRectangle(X1+i,Y1+i,X1+lengte-i,Y1+i+18,clGreen)
   FGLFillRectangle(X1+i,Y1+i+19,X1+lengte-i,Y1+hoogte-i,clSilver)
   aOldView := FGLSetViewport(X1+30,Y1+i+1,X1+lengte-i-1,Y1+i+20)
   FGLText(X1+32,Y1+i+2,clWhite,-1,string)
   FGLSetViewport(aOldView[1],aOldView[2],aOldView[3],aOldView[4])
 FGLMShow()
RETURN

/***
 This function draws a Windows 3.11 style window
***/
PROCEDURE WinWindow(X1,Y1,lengte,hoogte,string)
Local i,aOldView,t

 FGLMHide()
   i := 0
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clBlack); i++
	FGLSetColor(clRed)
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clBlack)
   // finishing touch
	FGLSetColor(clBlack)
   FGLLine(X1+20+i,Y1,X1+20+i,Y1+hoogte)
   FGLLine(X1+lengte-i-20,Y1,X1+lengte-i-20,Y1+hoogte)
   FGLLine(X1,Y1+i+20,X1+lengte,Y1+i+20)
   FGLLine(X1,Y1+hoogte-i-20,X1+lengte,Y1+hoogte-i-20)
   i++
   FGLFillRectangle(X1+i,Y1+i,X1+lengte-i,Y1+i+18,clBlue)
   FGLFillRectangle(X1+i,Y1+i+20,X1+lengte-i,Y1+hoogte-i,clWhite)
   t := X1+(lengte/2)-((len(string)*(FGLSetMode()[FGL_MODE_FONT_WIDTH]/2)))
   aOldView := FGLSetViewport(X1+i+1,Y1+i+1,X1+lengte-i-1,Y1+i+20)
   FGLText(t,Y1+i+2,clWhite,-1,string)
   FGLSetViewport(aOldView[1],aOldView[2],aOldView[3],aOldView[4])
 FGLMShow()
RETURN

/***
 This function draws a Windows 3.11 style dialog box
***/
PROCEDURE Dlgbox(X1,Y1,lengte,hoogte,string)
   local vpx1:=X1,vpy1:=Y1,vpx2:=X1+lengte,vpy2:=Y1+hoogte
   local i,t,aOldView

 FGLMHide()
   i := 0
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clBlack); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clGreen); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clGreen); i++
   FGLRectangle(X1+i,Y1+i,X1+lengte-i,Y1+hoogte-i,clWhite); i++
   FGLFillRectangle(X1+i,Y1+i,X1+lengte-i,Y1+i+14,clGreen)

   aOldView := FGLSetViewport(X1+i+1,Y1+i,X1+lengte-i-1,Y1+i+15)
   t := X1+(lengte/2)-((len(string)*(FGLSetMode()[FGL_MODE_FONT_WIDTH])/2))
   FGLText(t,Y1+i,clWhite,-1,string)
   FGLSetViewport(aOldView[1],aOldView[2],aOldView[3],aOldView[4])

   FGLLine(X1+i,Y1+i+15,X1+lengte-i,Y1+i+15,clBlack)
   FGLFillRectangle(X1+i,Y1+i+16,X1+lengte-i,Y1+hoogte-i,clSilver)
 FGLMShow()
RETURN

/***
 This function draws an empty button
***/
PROCEDURE Button(X1,Y1,Width,Height)
   local X2,Y2

   X2 := X1 + Width
   Y2 := Y1 + Height

   FGLFillRectangle(X1+2,Y1+2,X2-2,Y2-2,clSilver)
   FGLLine(X1+1,Y1,X2-1,Y1,clBlack)
   FGLLine(X1+1,Y2,X2-1,Y2,clBlack)
   FGLLine(X1,Y1+1,X1,Y2-1,clBlack)
   FGLLine(X2,Y1+1,X2,Y2-1,clBlack)
   FGLRectangle(X1+1,Y1+1,X2-1,Y2-1,clGray)
   FGLRectangle(X1+2,Y1+2,X2-2,Y2-2,clGray)
   FGLLine(X1+1,Y1+1,X2-1,Y1+1,clWhite)
   FGLLine(X1+1,Y1+1,X1+1,Y2-1,clWhite)
   FGLLine(X1+2,Y1+2,X2-2,Y1+2,clWhite)
   FGLLine(X1+2,Y1+2,X1+2,Y2-2,clWhite)
RETURN

/***
 This function draws a button with text (current font).
***/
PROCEDURE TextButton(X1,Y1,Width,Height,string)
   local mid1, mid2,aOldView,X2,Y2

   X2 := X1 + Width
   Y2 := Y1 + Height

   Button(X1,Y1,Width,Height)
   aOldView := FGLSetViewport(X1+2,Y1+2,X2-2,Y2-2)
   mid1 := X1 + (((X2-X1)/2)-((len(string)*FGLSetMode()[FGL_MODE_FONT_WIDTH])/2))
   mid2 := Y1 + ((Y2-Y1)/2)-(FGLSetMode()[FGL_MODE_FONT_HEIGHT]/2)+1
   FGLText(mid1,mid2,clBlack,-1,string)
   FGLSetViewport(aOldView[1],aOldView[2],aOldView[3],aOldView[4])
RETURN

/***
 This function loads all the standard buttons and adds them to the FGstdButton
 array. Uses FGbutton.ch
***/
PROCEDURE LoadButtons()
 aFGLButton := {}
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btnup.bmu"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btndown.bmu"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btnleft.bmu"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btnright.bmu"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btn.bmu"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btnup.bmd"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btndown.bmd"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btnleft.bmd"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btnright.bmd"),FGL_IMG_MAPONCURRENT))
 AADD(aFGLButton,FGLMakeDDB(FGLLoadBMP("bmp\btn.bmd"),FGL_IMG_MAPONCURRENT))
RETURN

FUNCTION GetButton(Num)
 IF (Num >= 0 .AND. Num <= LEN(aFGLButton))
  RETURN aFGLButton[Num]
 ENDIF
RETURN NIL
