/***
 Ferns' Graphics Library v1.5 (also works for 3.0)

 MENU TO replacement...
 and ALERT replacement

 Please change these functions if you don't like them...

 (C)Copyright 1995-1996, Ferns Paanakker.
***/
#include "inkey.ch"
#include "fgl.ch"

STATIC aPrompt  := {}        // Static array to handle MENU TO replacement

MEMVAR GetList               // Allow the use of public GetList variable
                             // without warnings


									  // Group Menu To
                             // Note : Here are some CA-CLIPPER
                             // modified functions to allow mouse
                             // and graphics use of Menu To
                             // Do not change them until you want to change
                             // the behaviour of MENU TO
/***
*
*  @ ...,... PROMPT ... MESSAGE ...  / MENU TO
*
*  Standard MENU TO replacement system
*
*/
#DEFINE n_Prompt_Row     1
#DEFINE n_Prompt_Col     2
#DEFINE n_Prompt_Col_End 3
#DEFINE c_Prompt_Item    4
#DEFINE c_Prompt_Msg     5
#DEFINE c_Prompt_Key     6


FUNCTION __AtPrompt(nRow,nCol,cPrompt,cMsg)

  // Ferns' Graphics Library : if cMsg is NIL, then change message to ""
  IF (cMsg == NIL) ; cMsg := "" ;  ENDIF

	AADD(aPrompt , { nRow                        ,;
                    nCol                        ,;
                    nCol+LEN(cPrompt)-1         ,;
                    cPrompt                     ,;
                    cMsg                        ,;
                    UPPER(LEFT(cPrompt+" ",1))   ;
                  }                              ;
       )

   DEVPOS(nRow,nCol)
   DEVOUT(cPrompt)

RETURN (NIL)



FUNCTION __MenuTo(bChoice,cVarName)

   LOCAL nChoice        := 1
   LOCAL nChoOld        := 1

   LOCAL nI             := 0
   LOCAL nKey           := 0

   LOCAL aState         := FGLM_INIT_STATE

   LOCAL lExitRequested := .F.
   LOCAL lNeedRefresh   := .F.
   LOCAL lNoEvent       := .T.

   LOCAL nSaveRow       := ROW()
   LOCAL nSaveCol       := COL()
   LOCAL nSaveCur       := SETCURSOR()
   LOCAL cSaveColor     := SETCOLOR()

   LOCAL cColorHig      := ""
   LOCAL lWrapMode      := Set( _SET_WRAP )

   LOCAL aLocalPrompt   := {}

	LOCAL aOrigin

	LOCAL oldState


	nChoice := EVAL(bChoice,1)

   IF LEN(aPrompt)==0
      RETURN (0)
   ENDIF

	nChoice := IF(nChoice>0 .AND. nChoice<=LEN(aPrompt),nChoice,1)

   cColorHig := RIGHT(cSaveColor,LEN(cSaveColor)-AT(",",cSaveColor+","))
   cColorHig := LEFT(cColorHig,AT(",",cColorHig)-1)


   SETCURSOR(0)

   __MenuToMsg(aPrompt[nChoice,c_Prompt_Msg])
	SETCOLOR(cColorHig)
   DEVPOS(aPrompt[nChoice,n_Prompt_Row],aPrompt[nChoice,n_Prompt_Col])
   DEVOUT(aPrompt[nChoice,c_Prompt_Item])
   SETCOLOR(cSaveColor)

	oldState := FGLMState()
	IF oldState[FGLM_STATE_VISIBLE] == .F.   // cursor was hidden
	  FGLMShow()
	ENDIF


   aState := FGLM_INIT_STATE
   lExitRequested := .F.

   DO WHILE !lExitRequested

      lNoEvent := .T.
      DO WHILE lNoEvent

         IF (nKey:=INKEY())<>0

            IF ( SETKEY(nKey)<>NIL )

               aLocalPrompt := ACLONE(aPrompt)
               aPrompt := {}
               EVAL( SETKEY(nKey) ,PROCNAME(1),PROCLINE(1),cVarName )
               aPrompt := ACLONE(aLocalPrompt)
               LOOP

            ENDIF

            lNoEvent := .F.

         ELSE

            aState:=FGLMState()
            IF aState[FGLM_STATE_LEFT]==FGLM_BUTTON_DOWN .OR. aState[FGLM_STATE_RIGHT]==FGLM_BUTTON_DOWN
               lNoEvent := .F.
            ENDIF

         ENDIF
      ENDDO

      lNeedRefresh  := .F.

      DO CASE

         CASE nKey==K_ESC .OR. nKey==K_ENTER
              lExitRequested := .T.

         CASE nKey==K_LEFT .OR. nKey==K_UP

              lNeedRefresh := .T.
              nChoice -= 1
              IF nChoice==0
                 IF lWrapMode
                    nChoice := LEN(aPrompt)
                 ELSE
                    nChoice := 1
                 ENDIF
              ENDIF

         CASE nKey==K_RIGHT .OR. nKey==K_DOWN

              lNeedRefresh := .T.
              nChoice += 1
              IF nChoice==LEN(aPrompt)+1
                 IF lWrapMode
                    nChoice := 1
                 ELSE
                    nChoice := LEN(aPrompt)
                 ENDIF
              ENDIF


         CASE aState[FGLM_STATE_RIGHT]==FGLM_BUTTON_DOWN

              lExitRequested := .T.


         CASE aState[FGLM_STATE_LEFT]==FGLM_BUTTON_DOWN

              lExitRequested := .F.
				  // FGLibrary v1.5
				  // Make sure the logical origin is handled correctly
				  aOrigin := FGLSetBaseXY()
				  aState[FGLM_STATE_ROW] -= INT(aOrigin[2] / FGLSetMode()[FGL_MODE_FONT_HEIGHT])
				  aState[FGLM_STATE_COL] -= INT(aOrigin[1] / FGLSetMode()[FGL_MODE_FONT_WIDTH])

              FOR nI := 1 TO LEN(aPrompt)
						IF aState[FGLM_STATE_ROW]==aPrompt[nI,n_Prompt_Row] .AND. ;
                     aState[FGLM_STATE_COL]>=aPrompt[nI,n_Prompt_Col] .AND. ;
                     aState[FGLM_STATE_COL]<=aPrompt[nI,n_Prompt_Col_End]

                     nChoice := nI
                     lNeedRefresh := .T.
                     lExitRequested := .T.
                     EXIT

                  ENDIF
              NEXT

              IF !lExitRequested
                 nChoice := nChoOld
              ENDIF

         OTHERWISE

              IF nKey<>0

                 nChoice := ASCAN(aPrompt,{|el| el[c_Prompt_Key]==UPPER(CHR(nKey)) })

                 IF nChoice <> 0

                    lNeedRefresh := .T.
                    lExitRequested := .T.

                 ELSE

                    nChoice := nChoOld

                 ENDIF


              ENDIF

      ENDCASE

      FGLMHide()

      IF lNeedRefresh

         DEVPOS(aPrompt[nChoOld,n_Prompt_Row],aPrompt[nChoOld,n_Prompt_Col])
         DEVOUT(aPrompt[nChoOld,c_Prompt_Item])

         __MenuToMsg(aPrompt[nChoice,c_Prompt_Msg])
         SETCOLOR(cColorHig)
         DEVPOS(aPrompt[nChoice,n_Prompt_Row],aPrompt[nChoice,n_Prompt_Col])
         DEVOUT(aPrompt[nChoice,c_Prompt_Item])
         SETCOLOR(cSaveColor)

         nChoOld := nChoice

      ENDIF

      FGLMShow()

   ENDDO

   IF nKey==K_ESC .OR. aState[FGLM_STATE_RIGHT]==FGLM_BUTTON_DOWN
      nChoice := 0
   ENDIF

	IF oldState[FGLM_STATE_VISIBLE] == .F.   // cursor was hidden
     FGLMHide()
   ENDIF

   DEVPOS(nSaveRow,nSaveCol)
   SETCURSOR(nSaveCur)
   SETCOLOR(cSaveColor)

   aPrompt := {}

RETURN (nChoice)


FUNCTION __MenuToMsg(cMsg)

   STATIC cOldMsg := ""
   STATIC nOldRow := 0
   STATIC nOldCol := 0


   DEVPOS(nOldRow,nOldCol)
   DEVOUT(SPACE(LEN(cOldMsg)))


   cOldMsg := cMsg

   nOldRow := Set( _SET_MESSAGE )

   IF Set( _SET_MCENTER )

      nOldCol := INT( (MAXCOL()-LEN(cMsg))/2 )

   ELSE

      nOldCol := 0

   ENDIF

	 DEVPOS(nOldRow,nOldCol)
    DEVOUT(cOldMsg)

RETURN (NIL)


/***
 New ALERT() with support for extended alphanumeric modes and graphical modes.
***/
FUNCTION ALERT(tekst,optlist)
local terug,rijen,kolommen,achter,oldView,oldBase
local textarray := {},i,tempstring
local Ypos,Xpos,oldColor,lengte,langste,hoogte
LOCAL aSaveKey[8],nN
LOCAL cSaveDev:=SET(_SET_DEVICE,"SCREEN")

 oldColor := SetColor("W+/R,W+/B,,,W+/G")
 rijen := FGLSetMode()[1]
 kolommen := FGLSetMode()[2]
 // Check for NIL.
 IF (len(tekst) == 0 .OR. PCOUNT() == 0)
  	RETURN NIL
 ENDIF
 IF (optlist == NIL)
 	optlist := {"Ok"}
 ENDIF

 // Calculate text.
  IF AT(";",tekst) == 0    // find first string
   AADD(textarray,tekst)
  ELSE
	AADD(textarray,SUBSTR(tekst,0,AT(";",tekst)-1) )
  ENDIF
  langste := len(textarray[1])
  tempstring := tekst
  i := 1
  DO WHILE (AT(";",tempstring) != 0)  // do while there is a ";".
	AADD(textarray,SUBSTR(tempstring,AT(";",tempstring)+1))
   i++
	tempstring := textarray[i]
	// Remove part before ";".
	IF (AT(";",textarray[i]) != 0)
		textarray[i] := SUBSTR(textarray[i],0,AT(";",textarray[i])-1)
	ENDIF
	IF (len(textarray[i]) > langste) ; langste := len(textarray[i]) ; ENDIF
  ENDDO

  hoogte := i+1
  // First calculate dimension and then draw.
  lengte := -2 // because the last + 2...
  FOR i := 1 TO LEN(optlist)
  	lengte += LEN(optlist[i])+2
  NEXT i
  IF (lengte > langste)
  	langste := lengte
  ENDIF

 // Now set the new logical origin.
 oldBase := FGLSetBaseXY(0,0,FGL_GRAPH)

  // Draw the ALERT box.

  oldView := FGLSetViewport(0,0,0,0)

  achter := SAVESCREEN((MAXROW()/2)-(hoogte/2)-1,(MAXCOL()/2)-(langste/2)-4,(MAXROW()/2)+(hoogte/2)+1,(MAXCOL()/2)+(langste/2)+4)

  @ (MAXROW()/2)-(hoogte/2)-1,(MAXCOL()/2)-(langste/2)-4,(MAXROW()/2)+(hoogte/2)+1,(MAXCOL()/2)+(langste/2)+4 ;
                          BOX ( CHR(218) + CHR(196) + CHR(191) + CHR(179) + ;
                          CHR(217) + CHR(196) + CHR(192) + CHR(179) + CHR(32)  ) COLOR "W+/R"

  Ypos := INT((MAXROW()/2)-(hoogte/2))
  FOR i := 1 TO LEN(textarray)
	Xpos := INT( MAXCOL()/2 - (LEN(textarray[i])/2) )
	@ Ypos,Xpos SAY textarray[i]
	Ypos++
  NEXT i

  Ypos++
  Xpos := INT( MAXCOL()/2 - lengte/2 )
  FOR i := 1 TO LEN(optlist)
	@ Ypos,Xpos PROMPT optlist[i]
	Xpos += LEN(optlist[i])+2
  NEXT i

 // Set the space key to be a "return". Disable other menu to termination keys

 aSaveKey[1]={32,SETKEY( 32, {|| __Keyboard(CHR(K_RETURN))})}
 aSaveKey[2]={K_HOME,SETKEY(K_HOME,{|| nN:=0})}
 aSaveKey[3]={K_END,SETKEY(K_END,{|| nN:=0})}
 aSaveKey[4]={K_PGUP,SETKEY(K_PGUP,{|| nN:=0})}
 aSaveKey[5]={K_PGDN,SETKEY(K_PGDN,{|| nN:=0})}
 aSaveKey[6]={K_UP,SETKEY(K_UP,{|| nN:=0})}
 aSaveKey[7]={K_DOWN,SETKEY(K_DOWN,{|| nN:=0})}


  MENU TO terug

 FOR i := 1 TO 7
	SETKEY( aSaveKey[i,1], aSaveKey[i,2])
 NEXT


  RESTSCREEN((MAXROW()/2)-(hoogte/2)-1,(MAXCOL()/2)-(langste/2)-4,(MAXROW()/2)+(hoogte/2)+1,(MAXCOL()/2)+(langste/2)+4,achter)
  SetColor(oldColor)
  FGLSetViewport(oldView[1],oldView[2],oldView[3],oldView[4])
 // Now restore old logical origin
 FGLSetBaseXY(oldBase[1],oldBase[2],FGL_GRAPH)

 SET(_SET_DEVICE, cSaveDev)

RETURN terug


